/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... pretezovani funkci, sablony, ukazatele na funkce, parametry programu, podmineny vyraz
*/
#include<iostream>
#include<string>
using namespace std;

int secti(int x, int y)
{
	return x + y;
}

int odecti(int x, int y)
{
	return x - y;
}

bool rostouci(double(*f) (double), double a, double b, double eps)
{
	for (double x = a; x + eps <= b; x += eps)
	{
		if (f(x) >= f(x + eps))
			return false;
	}
	return true;

}

void vypis1(int x)
{
	cout << "vypisuji int: " << x << endl;
}

void vypis1(double x)
{
	cout << "vypisuji double: " << x << endl;
}

/* sablony funkci */
template<typename T>
void vypis(T x)
{
	cout << "vypisuji: " << x << endl;
}

template<typename T>
void prohod(T &x, T &y)
{
	T z = x;
	x = y;
	y = z;
}

/* Sablona struktury */
template<typename T, typename S>
struct Batoh
{
	T data;
	S dalsi;
};

/* Sablona tridy */
template<typename T, typename S>
class Batoh1
{
	T data;
	S dalsi;
public:
	Batoh1(T _data, S _dalsi) : data(_data), dalsi(_dalsi)
	{

	}
	void nastavData(T data);
};

template<typename T, typename S>
void Batoh1<T, S>::nastavData(T data)
{
	this->data = data;
}

int main(int argc, char *argv[])
{
	/* sablony funkci */
	{
		int x = 2, y = 4;
		prohod(x, y);
		vypis(x);
		vypis<int>(5);
		vypis<double>(3.14);
		vypis("abcd");
		vypis<string>("abc");

	}
	/* sablony trid */
	{
		Batoh<int, string> modry;
		modry.data = 5;
		Batoh<string, double> cerveny;
		cerveny.data = "abcd";

		Batoh1<int, int> x(4, 5);
	}

	/* Ukazatele na funkce */
	{
		double(*f) (double);
		int(*g) (int, int);

		g = &secti;
		cout << (*g)(2, 6) << endl;

		g = odecti;
		cout << g(2, 6) << endl;

		f = sin;
		cout << f(0) << endl;
		f = cos;
		cout << f(0) << endl;

		if (rostouci(sin, 0, 3.14 / 2, 0.0001))
			cout << "sin roste" << endl;
		if (rostouci(cos, 0, 3.14 / 2, 0.0001))
			cout << "cos roste" << endl;
	}

	/* Podmineny vyraz */
	{
		double x = 7, y = -3, m;
		if (x >= y)
			m = x;
		else
			m = y;
		m = (x >= y) ? x : y;

		y = (y >= 0) ? y : -y;

		double a = 0, b = 1;
		bool v = (x > a) ? ((x < b) ? true : false) : false;
	}

	/* Vstupni parametry programu */
	{
		cout << "Parametry funkce main:\n";
		for (int i = 0; i < argc; i++)
		{
			cout << argv[i] << endl;
		}
	}
	return 0;
}
